monoalpha1:
	call VPutSscreen
 db "Monoalphabetic - Intro",0
 db "The Monoalphabetic cipher",0
 db "is also simple and old. You",0
 db "replace every character",0
 db "with another. Consequently",0
 db "the key exists of 26 letters.",0
 db 0FFh
	ret


monoalpha2:
	call VPutSscreen
 db "Monoalphabetic - Encrypt",0
 db "When you encrypt attack",0
 db "and part of the key is A=T,",0
 db "C=R,K=A and T=Z, you will",0
 db "get:",0
 db 0FFh
	ld bc,2*256+5
	ld (curRow),bc
	ld hl,attack
	call PutS
	ret
monoalpha2_ani:
	call monoalpha2
	set fastforwardicon,(IY+asm_Flag2)
	res fastforward,(IY+asm_Flag1)
	ld bc,2*256+5
	ld (curRow),bc
	ld hl,attack_enc
monoalpha2_loop:
	call Delay100_double
	ld a,(hl)
	or a
	jr z,monoalpha2_exit
	inc hl
	B_CALL PutC
	jr monoalpha2_loop
monoalpha2_exit:
	res fastforwardicon,(IY+asm_Flag2)
	ret
attack:
 db "ATTACK",0
attack_enc:
 db "TZZTRA",0

monoalpha3:
	call VPutSscreen
 db "Monoalphabetic - Keys",0
 db "The number of possible",0
 db "keys is very high because",0
 db "you have 26 characters to",0
 db "choose from for the A, 25",0
 db "for the B, ... ,2 for the Y,",0
 db "1 for the Z.",0
 db 0FFh
	ret

monoalpha4:
	call VPutSscreen
 db "Monoalphabetic - Keys2",0
 db "That means you have",0
 db "26*25*..*2*1 possible",0
 db "keys. In common math",0
 db "notation this is 26!. 26! is",0
 db "roughly 4.03",Lexponent,"26, that are",0
 db "too many keys to try.",0
 db 0FFh
	ret

monoalpha5:
	call VPutSscreen
 db "Monoalphabetic - Crack",0
 db "To crack it we need a",0
 db "smarter way. You can",0
 db "count how often every",0
 db "character appears. Then",0
 db "match that with how often",0
 db "the character should",0
 db "appear statistically.",0
 db 0FFh
	ret

;6=crack animatie

monoalpha7:
	pop hl
monoalpha7_nopop:
	B_CALL GrBufClr
	ld hl,chancetablestr
	ld a,0
	ld c,32
	call Displaykey
	call VPutSscreen
 db "Monoalphabetic - Exercise",0
 db "There are no exercises",0
 db "but you can take a look at",0
 db "a chance table. So you",0
 db "can see how often a",0
 db "character appears",0
 db "statistically.",0
 db 0FFh
monoalpha7_keyloop:
	B_CALL GetKey
	cp kYequ
	jr z,monoalpha_chancetable
	cp kWindow
	jr z,monoalpha_chancetable
	call readkeys
	jr monoalpha7_keyloop

chancetablestr:
	db "  CHANCES",0

monoalpha_chancetable:
	set continueicon,(IY+asm_flag2)
	B_CALL GrBufClr
	ld hl,monoalpha_chancetable_table2
	ld e,29
	call VPutSmultiple
	ld e,51
	call VPutSmultiple
	ld e,73
	call VPutSmultiple
	call VPutSscreen
 db "Monoalphabetic - Chances",0
 db "A=8.0",0
 db "B=1.5",0
 db "C=3.1",0
 db "D=4.0",0
 db "E=12.5",0
 db "F=2.3",0
 db "G=2.0",0
 db 0FFh
monoalpha_chancetable_keyloop:
	B_CALL GetKey
	call smallreadkeys
	res continueicon,(IY+asm_flag2)
	jr monoalpha7_nopop

monoalpha_chancetable_table2:
 db "H=5.5",0
 db "I=7.3",0
 db "J=0.2",0
 db "K=0.7",0
 db "L=4.1",0
 db "M=2.5",0
 db "N=7.1",0
 db 0FFh
 db "O=7.6",0
 db "P=2.0",0
 db "Q=0.1",0
 db "R=6.1",0
 db "S=6.5",0
 db "T=9.3",0
 db "U=2.7",0
 db 0FFh
 db "V=1.0",0
 db "W=2.0",0
 db "X=0.2",0
 db "Y=1.7",0
 db "Z=0.1",0
 db "(In ",Lpercent," )",0
 db 0FFh