xor1:
	call VPutSscreen
 db "XOR - Intro",0
 db "The XOR cipher is a one",0
 db "time pad, that means that",0
 db "you can only use a key",0
 db "once. It can't be cracked",0
 db "as longas the key isn't",0
 db "predictable.",0
 db 0FFh
	ret

xor2:
	call VPutSscreen
 db "XOR - Encrypt1",0
 db "You first need to convert",0
 db "your message to 1s and 0s.",0
 db "You do that by replacing",0
 db "every character with their",0
 db "place in the alphabet. For",0
 db "example A=1,B=2,...,Z=26.",0
; db "You convert the characters",0
; db "to numbers according to",0
; db "their place in the alpabet.",0
 db 0FFh
	ret

xor3:
	call VPutSscreen
 db "XOR - Encrypt2",0
 db "Second, you take every",0
 db "number and if it's larger",0
 db "than 16 you write a 1 and",0
 db "substract 16 from it, if it's",0
 db "not a 0. You then do this",0
 db "using 8,4,2 and 1 with the",0
 db "previous answer.",0
 db 0FFh
	ret

xor4:
	call VPutSscreen
 db "XOR - Encrypt3",0
 db "This is what happens when",0
 db "you convert hat.",0
 db 0FFh
	ret
xor4_ani:
	set fastforwardicon,(IY+asm_Flag2)
	call xor4
 	ld hl,1*256+3
	ld (currow),hl
	ld hl,selfmodifyingcode
	ld a,0CBh
	ld (hl),a
	inc hl
	inc hl
	ld a,0C9h ;ret
	ld (hl),a
	res fastforward,(IY+asm_Flag1)
 	VPutSScreen 4,23,"H is 8th in the alphabet"
	call xor4_delayclearrow
	ld c,8
	call xor4_showbyte
	res fastforward,(IY+asm_Flag1)
 	VPutSScreen 4,23,"A is 1st in the alphabet"
	call xor4_delayclearrow
	ld c,1
	call xor4_showbyte
	res fastforward,(IY+asm_Flag1)
 	VPutSScreen 4,23,"H is 20th in the alphabet"
	call xor4_delayclearrow
	ld c,20
	call xor4_showbyte
 	VPutSScreen 4,23,"Message converted"
	res fastforwardicon,(IY+asm_Flag2)
	ret

xor4_showbyte:
	res textWrite, (IY + sGrFlags)
	ld hl,(currow)
	inc l
	ld h,1
	ld (currow),hl
	ld b,5
	ld hl,23*256+4
	ld (pencol),hl
xor4_showbyte_loop:
	push bc
	ld a,c
	call VDisplayA
	pop bc
	push bc
	ld a,b
	dec a
	add a
	add a
	add a
	ld b,a
	add 01000001b ;bit 0,c
	ld (selfmodifyingcode+1),a
	call selfmodifyingcode ;bit b,c
	jr z,xor4_showbyte_loop_0
	ld a,b
	add 11000111b ;set b,a
	ld (selfmodifyingcode+1),a
	xor a
	call selfmodifyingcode ;set b,a
	pop de
	push de
	push bc
	push af
	cp e
	jr nz,xor4_showbyte_loop_less
	ld hl,equalstr
	jr xor4_showbyte_loop_equal
xor4_showbyte_loop_less:
	ld hl,morestr
xor4_showbyte_loop_equal:
	call VPutS
	pop af
	call VDisplayA
	ld hl,a1str
	call VPutS
	call Put1
	call xor4_delayclearrowsetloc
	pop bc
	pop de
	push de
	push bc
	ld a,e
	call VDisplayA
	ld a,"-"
	B_CALL VPutMap
	pop af
	push af
	add 11000111b ;set b,a
	ld (selfmodifyingcode+1),a
	xor a
	call selfmodifyingcode ;set b,a
	call VDisplayA
	ld a,"="
	B_CALL VPutMap
	pop af
	pop bc
	add 10000001b ;res 0,c
	ld (selfmodifyingcode+1),a
	call selfmodifyingcode ;res b,c
	push bc
	jr xor4_showbyte_loop_1
xor4_showbyte_loop_0:
	push bc
	ld hl,lessstr
	call VPutS
	pop af
	add 11000111b ;set b,a
	ld (selfmodifyingcode+1),a
	xor a
	call selfmodifyingcode ;set b,a
	call VDisplayA
	ld hl,a0str
	call VPutS
	call Put0
	call xor4_delayclearrowsetloc
xor4_showbyte_loop_1:
	pop bc
	dec b
	jp nz,xor4_showbyte_loop
	set textWrite, (IY + sGrFlags)
	ld a,80h+22
	B_CALL ClearRow
	ret

equalstr:
 db " is equal to ",0
lessstr:
 db " is less than ",0
morestr:
 db " is more than ",0
a0str:
 db ", a 0",0
a1str:
 db ", a 1",0

Put1:
	ld a,"1"
	jr Put
Put0:
	ld a,"0"
Put:
	B_CALL PutC
	ret
xor4_delayclearrowsetloc:
	ld hl,23*256+4
	ld (pencol),hl
xor4_delayclearrow:
	call Delay100_fivetimes
	ld a,80h+22
	B_CALL ClearRow
	ret

xor5:
	call VPutSscreen
 db "XOR - Encrypt4",0
 db "To encode the 0s and 1s you",0
 db "need a key with the same",0
 db "number of 0s and 1s. You",0
 db "compare every number of",0
 db "both, if they're the same",0
 db "you write a 0 otherwise a 1.",0
 db 0FFh
	ret

xor6:
	call VPutSscreen
 db "XOR - Encrypt5",0
 db "This is what happens when",0
 db "you encode.",0
 db 0FFh
xor6_textstrminus10:
 	PutS 1,4,"TEXT:010001010"
	PutS 1,5,"KEY :110010111"
	PutS 1,6,"CODE:"
	ret
xor6_ani:
	set fastforwardicon,(IY+asm_Flag2)
	call xor6
	VPutSScreen 4,23,"Encode using text and key"
	ld hl,encodedstr
	res fastforward,(IY+asm_Flag1)
	call xor6_putstr
	res fastforward,(IY+asm_Flag1)
	VPutSScreen 4,23,"Now the other way around"
	set continueicon,(IY+asm_Flag2)
	res fastforwardicon,(IY+asm_Flag2)
	B_CALL GetKey ;cont
	call smallreadkeys
	set fastforwardicon,(IY+asm_Flag2)
	res continueicon,(IY+asm_Flag2)
	ld a,80h+4*8
	B_CALL ClearRow
	PutS 1,4,"TEXT:"
	ld hl,xor6_textstrminus10+10
	call xor6_putstr
	call Delay100_triple
	ld a,80h+22
	B_CALL ClearRow
	VPutSScreen 4,23,"We got our text back!"
	res fastforwardicon,(IY+asm_Flag2)
	ret
encodedstr:
 db "100011101",0
xor6_putstr:
	ld a,(hl)
	inc hl
	or a
	ret z
	push af
	call Delay100_triple
	ld a,80h+22
	B_CALL ClearRow
	pop af
	push af
	push hl
	cp "0"
	jr nz,xor6_putstr1
	VPutSScreen 4,23,"The same, a 0"
	jr xor6_putstr0
xor6_putstr1:
	VPutSScreen 4,23,"Different, a 1"
xor6_putstr0:
	pop hl
	pop af
	B_CALL PutC
	jr xor6_putstr

xor7:
	call VPutSscreen
 db "XOR - Decrypt1",0
 db "As you have seen you can",0
 db "decrypt the same way as",0
 db "you encrypt. To get the",0
 db "real text you add 16,8,4,2",0
 db "and 1 if the 1st,..,5th",0
 db "number is 1.",0
 db 0FFh
	ret

xor8:
	call VPutSscreen
 db "XOR - Decrypt2",0
 db "This is what happens when",0
 db "you convert hat back.",0
 db 0FFh
	ld hl,1*256+3
	push hl
	ld (currow),hl
	ld hl,xor8_str
	ld b,3
xor8_strloop:
	ex de,hl
	ld hl,(currow)
	ld h,1
	inc l
	ld (currow),hl
	ex de,hl
	call PutS
	djnz xor8_strloop
 	ret
xor8_ani:
	set fastforwardicon,(IY+asm_Flag2)
	call xor8
 	ld hl,1*256+3
	ld (currow),hl
	ld hl,xor8_str
	res textWrite, (IY + sGrFlags)
	call xor8_putstr
	push hl
	call xor4_delayclearrowsetloc
	VPutS 4,23,"8th in the alphabet is the H"
	ld a,"H"
	B_CALL PutMap
	pop hl
	call xor8_putstr
	push hl
	call xor4_delayclearrowsetloc
	VPutS 4,23,"1st in the alphabet is the A"
	ld a,"A"
	B_CALL PutMap
	pop hl
	call xor8_putstr
	call xor4_delayclearrowsetloc
	VPutS 4,23,"20th in the alphabet is the T"
	ld a,"T"
	B_CALL PutMap
	call xor4_delayclearrowsetloc
	VPutS 4,23,"Converted hat back"
	set textWrite, (IY + sGrFlags)
	res fastforwardicon,(IY+asm_Flag2)
	ret
xor8_str:
 db "01000",0
 db "00001",0
 db "10100",0
xor8_putstr:
	ex de,hl
	ld hl,selfmodifyingcode
	ld a,0CBh
	ld (hl),a
	inc hl
	inc hl
	ld a,0C9h ;ret
	ld (hl),a
	res fastforward,(IY+asm_flag1)
	ld hl,(currow)
	ld h,1
	ld a,l
	cp 6
	ret z
	inc l
	ld (currow),hl
	ex de,hl
	ld c,0
xor8_putstr_loop:
	ld a,(hl)
	inc hl
	or a
	ret z
	push hl
	push af
	push bc
	call xor4_delayclearrowsetloc
	pop bc
	pop af
	set textInverse, (IY + textFlags)
	B_CALL PutC
	res textInverse, (IY + textFlags)
	ld b,a
	push bc
	cp "0"
	jr nz,xor8_putstr_loop_1
	ld hl,xor8_str0
	call VPutS
	jr xor8_putstr_loop_0
xor8_putstr_loop_1:
	ld hl,xor8_str1
	call VPutS
xor8_putstr_loop_0:
	ld hl,xor8_add
	call VPutS
	ld a,(curcol)
	dec a
	ld b,a
	ld a,5
	sub b
	add a
	add a
	add a
	add 11000111b ;set b,a
	ld (selfmodifyingcode+1),a
	xor a
	call selfmodifyingcode ;set b,a
	pop bc
	ld d,a
	ld a,b
	ld b,c
	cp "0"
	jr z,xor8_putstr_loop_skip0
	ld a,c
	add d
	ld b,a
xor8_putstr_loop_skip0:
	ld a,d
	push bc
	call VDisplayA
	ld hl,xor8_to
	call VPutS
	pop bc
	ld a,c
	ld c,b
	push bc
	call VDisplayA
	pop bc
	pop hl
	jr xor8_putstr_loop

xor8_str0:
 db "A 0, don't",0
xor8_str1:
 db "A 1,",0
xor8_add:
 db " add ",0
xor8_to:
 db " to ",0

xor9:
	call VPutSscreen
 db "XOR - Crack",0
 db "This cipher can't be",0
 db "cracked unless there is",0
 db "regularity in the key.",0
 db "Although this cipher is safe,",0
 db "it isn't used much because",0
 db "you need to exchange very",0
 db "long keys.",0
 db 0FFh
	ret

xor10:
	call VPutSscreen
 db "XOR - Exercise",0
 db "Because this cipher is very",0
 db "hard to crack there are no",0
 db "exercises.",0
 db 0FFh
 	ret