 ifdef unused
Getcsc:
	ei
	halt
	B_CALL GetCSC
	or a
	jr z,Getcsc
	ret
 endif

Displaykey15:
	ld c,15
Displaykey:
	push bc
	push hl
	push af
	ld b,6
	ld e,57
	call putvertline
	pop af
	inc a
	push af
	ld b,1
	ld e,56
	call putvertline
	pop af
	inc a
	ld l,a
	ld h,57
	ld (pencol),hl
	pop hl
	push af
	call VPutS
	pop af
	pop bc
	push bc
	push af
	ld e,56
	call puthorizonline
	pop af
	pop bc
	add a,c
	push af
	ld b,1
	ld e,56
	call putvertline
	pop af
	inc a
	ld b,6
	ld e,57
	call putvertline
	ret
quitstr:
 db "QUIT",0

DisplayA: ;prints a
	B_CALL SetXXOP1
	ld a,6
	B_CALL FormEReal
	ld hl,OP3
	B_CALL PutS
	ret

VDisplayA: ;prints a
	B_CALL SetXXOP1
	ld a,6
	B_CALL FormEReal
	ld hl,OP3
	B_CALL VPutS
	ret

Drawrect:;bc is lb, hl is ro
	push hl
	push bc
	ld a,b
	sub h
	dec b
	ld b,a
	push bc
	ld e,h
	ld a,l
	call putvertline
	pop bc
	pop de
	pop hl
	push hl
	push de
	ld a,e
	ld e,h
	call putvertline
	pop de
	pop hl
	push hl
	push de
	ld a,e
	sub l
	inc a
	ld c,a
	push bc
	ld a,l
	ld e,h
	call puthorizonline
	pop bc
	pop de
	pop hl
	ld a,l
	ld e,d
	call puthorizonline
	ret	

fillrect:
	ld a,e
	sub l
	inc a
	ld c,a
	ld a,l
	ld e,h
	push af
fillrect_loop:
	pop af
	push af
	push bc
	push de
	call puthorizonline
	pop de
	inc e
	ld a,d
	cp e
	pop bc
	jr nz,fillrect_loop
	pop af
	ret
	

puthorizonline: 	;a=x e=y c=length(min 8)  destroyed:HL,DE,BC,AF
	push bc
	call bufferloc
	pop bc
	ld b,a
	ld a,8
	sub b
	ld d,a
	ld a,c
	sub d
	ld d,0FFh
	inc b
	dec b
	jr z,puthorizonline_shiftloopskip
puthorizonline_shiftloop:
	srl d
	djnz puthorizonline_shiftloop
	push af
	ld a,d
	or (hl)
	ld d,a
	pop af
	jr puthorizonline_putloopentry
puthorizonline_shiftloopskip:
puthorizonline_putloop:
	ld d,0FFh
puthorizonline_putloopentry:
	ld (hl),d
	inc hl
	sub 8
	jr nc,puthorizonline_putloop
	add 8
	ld b,a
	ld a,8
	sub b
	ld b,a
	ld d,0FFh
	jr z,puthorizonline_shiftloop2skip
	puthorizonline_shift2loop:
	sla d
	djnz puthorizonline_shift2loop
	ld a,d
	or (hl)
	ld (hl),a
puthorizonline_shiftloop2skip:
	ret

putvertline: 	;a=x e=y b=length  destroyed:HL,DE,BC,AF
	push bc
	call bufferloc
	push hl
	ld hl,putvertline_code_begin
	ld de,selfmodifyingcode
	ld bc,putvertline_code_end-putvertline_code_begin
	ldir

	ld c,a
	ld a,7
	sub c
	add a
	add a
	add a ;*8
	add 0C6h
	ld (putvertline_code_modifypoint-putvertline_code_begin+selfmodifyingcode),a

	ex de,hl ;to put the ret
	ld (hl),0C9h ;ret

	pop hl
	pop bc
	ld de,12 ;skip one line everytime
	jp selfmodifyingcode ;use the ret in selfmodyfingcode
putvertline_code_begin:
	add hl,de
	db 0CBh				;bit c,(hl)
putvertline_code_modifypoint:
	db 0
	djnz putvertline_code_begin ;works because of relative addressing
	ret
putvertline_code_end:

;vakjechange:
	push bc
	call vakjeinvert
	pop bc
	ld a,b
	ld (currentselected),a
	call vakjeinvert
	ret

vakjeinvert:
	ld a,(currentselected)
	ld b,a
	ld a,1
vakjecijfers_multloop:
	add 10
	djnz vakjecijfers_multloop
	ld e,a
	ld ix,vakjecijfers_sprite
	ld a,1
	call putsprite
	ret

vakjecijfers:
	ld hl,11*256+4
	ld c,"1"-1
vakjecijfers_loop:
	ld (penCol),hl
	inc c
	ld a,c
	B_CALL VPutMap
	res textInverse, (IY + textFlags)
	ld a,h
	add 10
	ld h,a
	djnz vakjecijfers_loop
	ret

vakjecijfers_sprite:
	db 0FFh,80h
	db 0FFh,80h
	db 0FFh,80h
	db 0FFh,80h
	db 0FFh,80h
	db 0FFh,80h
	db 0FFh,80h
	db 0,0
	db 0,0
	db 0,0
	db 0,0

vakjes:
	ld ix,vakjes_sprite
	ld de,9
vakjes_loop:
	push bc
	push de
	ld a,d
	call putsprite
	pop de
	pop bc
	ld ix,vakjes_sprite2
	ld a,e
	cp 9
	jr nz,vakjes_loop_skip
	inc a
vakjes_loop_skip:
	add 10
	ld e,a
	djnz vakjes_loop
	ret

vakjes_sprite:
	db 0FFh,0E0h
vakjes_sprite2:
	db 0,10h
	db 0,10h
	db 0,10h
	db 0,10h
	db 0,10h
	db 0,10h
	db 0,10h
	db 0,10h
	db 0,10h
	db 0FFh,0E0h
	db 0,0

indirectcall:
	jp (hl)

StrCopy:
	ld de,tempSwapArea+1
StrCopy_loop:
	ld a,(hl)
	ld (de),a
	inc hl
	inc de
	or a
	jr nz,StrCopy_loop
	ld de,tempSwapArea+1
	ret

TopRect:
	ld de,plotsscreen
	ld b,8
TopRect_loop:
	push bc
	ld hl,TopRect_rectangle
	ld bc,12
	ldir
	pop bc
	djnz TopRect_loop
	ret
TopRect_rectangle:
	db 1Fh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0FFh,0F8h
					 
VPutSscreen:
	call TopRect
	pop hl
	call VPutSICenter
	ld e,4
	call VPutSmultiple
	push hl
	B_CALL GrBufCpy
	ret

VPutSmultiple: ;de=pencol hl=strs ending with FFh
	ld d,2
VPutSmultiple_loop:
	ld a,d
	add 7
	ld d,a
	ld (pencol),de
	push de
	call StrCopy
	push hl
	ex de,hl
	B_CALL VPutS
	pop hl
	ld a,(hl)
	inc a
	pop de
	jr nz,VPutSmultiple_loop
	inc hl
	ret

VPutSICenter:
	set textInverse, (IY + textFlags)
	ld a,0
	ld (penrow),a
	call StrCopy
	push hl
	ex de,hl
	B_CALL StrLength
	dec hl
	ld (hl),c
	B_CALL SStringLength
	sra b
	ld a,30h
	sub b
	ld (pencol),a
	inc hl
	B_CALL VPutS
	res textInverse, (IY + textFlags)
	pop hl
	ret

VPutSIMacro:
	set textInverse, (IY + textFlags)
	pop hl
	call VPutSMacros
	push hl
	res textInverse, (IY + textFlags)
	ret

VPutSScreenMacro:
	res textWrite, (IY + sGrFlags)
	pop hl
	call VPutSMacros
	push hl
	set textWrite, (IY + sGrFlags)
	ret

VPutSMacro:
	pop hl
	call VPutSMacros
	push hl
	ret
VPutSMacros:
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld (pencol),de
	call VPutS
	ret

MultiPutS: ;b=nr of lines
	ex de,hl
	ld hl,1*256+2
	ld (curRow),hl
	ex de,hl
MultiPutS_loop:
	ex de,hl
	ld hl,(curRow)
	ld h,1
	inc l
	ld (curRow),hl
	ex de,hl
	call PutS
	djnz MultiPutS_loop
	ret

PutSMacro:
	pop hl
	ld d,(hl)
	inc hl
	ld e,(hl)
	inc hl
	ld (curRow),de
	call PutS
	push hl
	ret
Delay100_fivetimes:
	ld bc,450
	jr Delay100_start
Delay100_triple:
	ld bc,225
	jr Delay100_start
Delay100_double:
	ld bc,150
	jr Delay100_start
Delay100: ;from tutorial
 ld bc,90
Delay100_start:
 xor a
 bit fastforward,(IY+asm_Flag1)
 ret nz
 push	hl
 res	indicOnly,(IY+indicflags)
 set	apdAble,(IY+apdFlags)
 set	apdRunning,(IY+apdFlags)

d1001:
 ei
 halt
 push	bc
 B_CALL GetCSC
 pop	bc
 cp	0
 jr	nz,dkeys

 bit	onInterrupt,(IY+onFlags)
 res	onInterrupt,(IY+onFlags)
 jr	NZ,d1002

 dec	bc
 ld	a,b
 or	c
 jr	nz,d1001

d1002:
 pop	hl
 ret

dkeys:
	cp skLeft
	jr z,d1002_setff
	cp skEnter
	jr z,d1002_setff
	cp skClear
	jr z,d1002_setff
	cp skMode
	jr z,d1002_setff
	cp skRight
	jr z,d1002_setff
	res shift2nd,(IY+shiftFlags)
	jr d1001
d1002_setff:
	set fastforward,(IY+asm_Flag1)
	jr d1002

;from SDK
VPutS: 
	PUSH AF
	PUSH DE
;	PUSH IX
VPutS10:
	LD A,(HL) ; get a character of string name
	INC HL
	OR A ; end of string?
	JR Z, VputS20 ; yes --->
	B_CALL VPutMap ; display one character of string
	JR NC, VPutS10 ; display rest of string IF FITS
VputS20:
;	POP IX
	POP DE
	POP AF
	RET

PutS:
	PUSH BC
	PUSH AF
	LD A,(winBtm)
	LD B,A ; B = bottom line of window
PutS10:
	LD A,(HL) ; get a character of string name
	INC HL
	OR A ; end of string?
	SCF ; indicate entire string was	
	; displayed
	JR Z, PutS20 ; yes --->
	B_CALL PutC ; display one character of string
	;
	LD A,(curRow) ; check cursor position
	CP B ; off end of window?
	JR C,PutS10 ; no, display rest of string
PutS20:
	POP BC ; restore A (but not F)
	LD A,B
	POP BC ; restore BC
	RET

LdHLInd:
	LD A, (HL)
	INC HL
	LD H, (HL)
	LD L, A
	RET

bufferloc:
	ld d,0
	ld hl,0
	add hl,de
	add hl,de
	add hl,de ;hl=3*de
	add hl,hl
	add hl,hl ;hl=3*4*de=12*de
	ld de,plotSScreen
	add hl,de ;right line in gbuf
	ld b,a
	srl a
	srl a
	srl a ;remove last 3 bits because those are within a screenbyte
	ld e,a
	ld d,0
	add hl,de ;pointer to right byte
	ld a,b
	and 7 ;only get last three bits
	ret

putsprite: ;size of sprite=11*16(16) a=x-axis e=y-axis ix=pointer to sprite DESTROYS:ALL except hl
	push hl
	call bufferloc
	di
	exx ;switch to shadow registers
	ld b,a ;save nr of shifts
	exx ;switch back

	ld b,11 ;nr of loops
putsprite_displayhorizontalnext:
	exx ;to shadow
	ld a,b
	exx ;to normal
	
	dec b
	inc b
	ld c,(IX)
	ld d,(IX+1)
	ld e,0
	inc ix
	inc ix

	or a
	jr z,putsprite_shiftloop_skip
putsprite_shiftloop:
	srl c 
	rr d
	rr e ;one bit shift over three bytes
	dec a
	jr nz,putsprite_shiftloop
putsprite_shiftloop_skip:

	ld a,(hl)
	xor c
	ld (hl),a
	inc hl
	ld a,(hl)
	xor d
	ld (hl),a
	inc hl
	ld a,(hl)
	xor e
	ld (hl),a
	inc hl
	push de
	ld de,12-3 ;skip one line
	add hl,de
	pop de
	djnz putsprite_displayhorizontalnext ;will only be zero first time

	pop hl
	ei
	ret

arrows_on:
 db 00000b,0000000b,00000000b
 db 00000b,0010000b,01000000b
 db 00000b,0110000b,01100000b
 db 00000b,1110010b,01110000b
 db 00000b,0110000b,01100000b
 db 00000b,0010000b,01000000b
 db 00000b,0000000b,00000000b
arrows_off:
 db 00000b,00000000b,00000000b
 db 00000b,00000000b,00000000b
 db 00000b,00000000b,00000000b
 db 00000b,00000010b,00000000b
 db 00000b,00000000b,00000000b
 db 00000b,00000000b,00000000b
 db 00000b,00000000b,00000000b
 
cont_inverted:
 db 00111b,11111111b,11110000b
 db 01111b,11111111b,11111000b
 db 11100b,11011001b,10001100b
 db 11011b,10101010b,11011100b
 db 11100b,11011010b,11011100b
 db 01111b,11111111b,11111000b
 db 00111b,11111111b,11110000b

 db 00111b,11111111b,11110000b
 db 01000b,00000000b,00001000b
 db 10011b,00100110b,01110100b
 db 10100b,01010101b,00100100b
 db 10011b,00100101b,00100100b
 db 01000b,00000000b,00001000b
 db 00111b,11111111b,11110000b


fastforward_inverted:
 db 00111b,11111111b,11110000b
 db 01110b,01111100b,11111000b
 db 11110b,00011100b,00111100b
 db 11110b,00000100b,00001100b
 db 11110b,00011100b,00111100b
 db 01110b,01111100b,11111000b
 db 00111b,11111111b,11110000b

 db 00111b,11111111b,11110000b
 db 01001b,10000011b,00001000b
 db 10001b,11100011b,11000100b
 db 10001b,11111011b,11110100b
 db 10001b,11100011b,11000100b
 db 01001b,10000011b,00001000b
 db 00111b,11111111b,11110000b

interrupt_start:
	exx
	ex AF,AF'
	in a,(6)
	push af
interrupt_replace:
	ld a,0 ;replace
	out (6),a
	call notcopiedinterrupt
	pop af
	out (6),a
	ex AF,AF'
	exx
	jp 0038h
interrupt_end:

notcopiedinterrupt:
	bit noicon,(IY+asm_Flag2)
	ret nz
	ld hl,interruptcounter
	ld a,(hl)
	dec a
	ld (hl),a
	and 0Fh
	ret nz
	ld a,(hl)
	srl a
	cp 64
	jr c,notcopiedinterrupt_inv
	set inverted,(IY+asm_Flag2)
	jr notcopiedinterrupt_noinv
notcopiedinterrupt_inv:
	res inverted,(IY+asm_Flag2)
notcopiedinterrupt_noinv:
notcopiedinterrupt_skipnot128:
	di ;no interrupts during drawing
	ld hl,arrows_on
	bit fastforwardicon,(IY+asm_Flag2)
	jr z,notcopiedinterrupt_noff
	ld hl,fastforward_inverted
notcopiedinterrupt_noff:
	bit continueicon,(IY+asm_Flag2)
	jr z,notcopiedinterrupt_nocont
	ld hl,cont_inverted
notcopiedinterrupt_nocont:
	bit inverted,(IY+asm_Flag2)
	jr nz,notcopiedinterrupt_nocont_inv
	ld de,21
	add hl,de
notcopiedinterrupt_nocont_inv:
	ld b,3
notcopiedinterrupt_loop
	call lcd_delay
	ld a,3
	sub b
	add 20h+9
	out (10h),a
	call lcd_delay
	ld a,80h+56
	out (10h),a
	call lcd_delay
	push bc
	push hl
	ld b,7
	ld de,3
	call notcopiedinterrupt_displayline
	pop hl
	pop bc
	inc hl
	djnz notcopiedinterrupt_loop
	ret

notcopiedinterrupt_displayline:
	ld a,(hl)
	add hl,de
	call lcd_delay
	out (11h),a
	djnz notcopiedinterrupt_displayline
	ret

;from weirdman
lcd_delay:		;LCD driver delay in 6mhz mode
	push hl
	inc hl
	dec hl
	pop hl
	ret

;from sdk
setTofull:
	LD HL,YOffset ; address of split
	; attributes
	LD DE,savevals ; app defined RAM
	; location to save
	LD BC,5 ; save first 5 bytes
	LDIR ; save split
	; attributes
	LD A,(IY+sGrFlags) ; split flags ->
	; ACC
	LD (DE),A ; save split flags
	; in 6th byte
	RES grfSplit,(IY+sGrFlags)
	RES vertSplit,(IY+sGrFlags) ; set flags to
	; Full screen
	B_CALL SetNorm_Vals ; screen attributes
	; to full
	SET grfSplitOverride,(IY+sGrFlags)
	RET

rstrYOffset:
	RES grfSplitOverride,(IY+sGrFlags)
	LD DE,YOffset
	LD HL,savevals
	LD BC,5
	LDIR ; restore input
	; screen attributes
	LD A,(HL) ; get input split
	; flags
	LD (IY+sGrFlags),A ; restore
	RET

;from ti
;   this will handle turning off, battery pulls & GOTO's on errors
;
;****************************************************
;			Equates
;****************************************************
intrptEnPort	equ 3 ; interrupt enable (in/out) 
;_ClrCursorHook	equ 4F69h
_LCD_DRIVERON 	equ 4978h 
onFlags 		equ 9 ;on key flags 
onRunning 		equ 3 ; 1=calculator is running 
iall equ 1011b

QUITApp_savemenu2_unarchive:
	B_CALL Arc_Unarc
	jr QUITApp_savemenu

QUITApp_savemenu2_delnewappvar:
	ld hl,appvarname
	rst 20h
	B_CALL ChkFindSym
	B_CALL DelVarArc
QUITApp_savemenu2_createappvar:
	ld hl,appvarname
	rst 20h
	ld hl,6
	B_CALL CreateAppVar
	inc de
	inc de
	ld hl,appvarcheckbytes+2
	ld bc,4
	ldir

QUITApp_savemenu:
	ld hl,appvarname
	rst 20h
	B_CALL ChkFindSym
	jr c,QUITApp_savemenu2_createappvar
	ld a,b
	or a
	jr nz,QUITApp_savemenu2_unarchive
	ld hl,appvarcheckbytes
	ld b,6
QUITApp_savemenu2_checkbytesloop:
	ld a,(de)
	cp (hl)
	jr nz,QUITApp_savemenu2_delnewappvar
	inc de
	inc hl
	djnz QUITApp_savemenu2_checkbytesloop
	ld hl,menuselected1
	ldi
	ldi ;copy two bytes
QUITApp:
	ld      sp,(quitSP)      ; restore sp so can do appofferr safely
   AppOffErr                ; remove error handler to kill GOTO's

AppPutaway:
	im 1 ;set back to ti's interrupt
	call rstrYOffset
	set grfSChanged, (IY+sgrflags);force update of graph buffer
	set graphDraw, (IY+graphFlags);force update of graph buffer
	set reTable,(IY+tblFlags) ;in case it is table/graph split

	res     plotLoc,(IY+plotFlags)      ; draws to display & buffer
   res     textWrite,(IY+sGrFlags)     ; small font written to dispaly

    b_call  ReloadAppEntryVecs          ; reload MON VECTORS with app loaders

    ld      (IY+textFlags),0

    bit     monAbandon,(IY+monFlags)    ; Is calc being turned off ?
    jr      nz, turningOff                ; jump if turning off

    ld      a,iall
    out     (intrptEnPort),a
    b_call  LCD_DRIVERON
    set     onRunning,(IY+onFlags)
    ei

    b_jump  JForceCmdNoChar

turningOff:
    b_jump  PutAway                     ; don't switch to home screen
                                        ; just do putaway of app
rawkeyHand:
dummyvector:
    ret
;   app's MON VECTOR table
AppVectors:
    dw      dummyvector
    dw      dummyvector
    dw      AppPutaway
    dw      dummyvector
    dw      dummyvector
    dw      dummyvector
    db      0

;   system error is being generated, kill the GOTO option.
NoGoTo:
    push    af
;   turning of the cursor hook is optional if you need to do it
;    b_call  ClrCursorHook
    res     curAble,(IY+curFlags)
    pop     af
    res     e_editf,a
    b_jump  JError
